<script setup lang="ts">
import { useUserStore } from '@/stores/user';
import { ref } from 'vue'
const UserStore = useUserStore()
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const show = ref(false)
function onSubmit(){
  form.value
}
const email = ref('')
function validateEmail(value:any) {
      // Regular expression for a simple email validation
      const emailRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;

      // Test the email against the regular expression
      return emailRegex.test(value) || "Invalid email address";
    }
</script>
<template>
    <v-dialog v-model="UserStore.dialog" persistent width="1024">
            <v-card>
              <v-card-title>
                <span class="text-h5">User Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="UserStore.editedUser.email"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Enter email', validateEmail]"
                          class="mb-2"
                          clearable
                          label="Email"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="UserStore.editedUser.fullname"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Enter name']"
                          class="mb-2"
                          clearable
                          label="Full Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="UserStore.editedUser.password"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please Enter password', (v) => (v && v.length >= 8) || 'Password must contain letters and numbers more than 8 characters']"
                          clearable
                          label="Password"
                          placeholder="Enter your password"
                          :type="show ? 'text' : 'password'"
                        ><template v-slot:append-inner>
                          <v-icon :icon="show ? 'mdi-eye' : 'mdi-eye-off'" @click="show = !show"></v-icon>
                        </template></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Gender"
                          :items="['male', 'female', 'others']"
                          v-model="UserStore.editedUser.gender"
                        ></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="UserStore.editedUser.role"
                          :items="[
                            { title: 'Manager', value: 'manager' },
                            { title: 'Staff', value: 'staff' }
                          ]"
                          label="Select roles"
                          :return-object="false"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="UserStore.closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="UserStore.save()" :disabled="!form"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
</template>